---
- block:
    - debug:
        msg: We can not install Azure-Arce in RHEL 6 and below version
    - fail:
        msg: This playbook does not work on current version of the OS
  when: ansible_distribution_majour_version == '6'

- block:
    - name: check if the arcagent is installed in Linux
      shell: azcmagent version
      register: old_arc_agent_version
      ignore_errors: yes

    - name: Check the resource group if host is already connected to Azure-Arc
      shell: azcmagent show | grep "Resource Group Name" | cut -d':' -f2-
      ignore_errors: true
      register: old_rg
      async: 120
      pool: 3

    - set_fact:
        new_rg: "{{azure_arc_agent_resourceGroup}}"

    - name: Disconnect the arc agent if it is already connected and connected to different ResourceGroup
      command: azcmagent disconnect \
                  --azure_arc_agent_service-principal-id "{{azure_arc_agent_client_id}}" \
                  --sazure_arc_agent_ervice-principal-secret "{{azure_arc_agent_client_secret}}"
      async: 120
      pool: 3
      ignore_errors: true
      when:
        - old_arc_agent_version != ""
        - old_rg != new_rg

    - name: Removing the previously installed azcmagent
      yum:
        name: azcmagent
        state: absent
      ignore_errors: true
      when:
        - old_arc_agent_version != ""

    - name: Install the Arc-Agent -- Downloading the Installation Script
      get_url:
        url: https://aka.ms/azcmagent
        dest: /tmp/Install_linux_azcmagent.sh
        mode: 0755

    - name: Install the Arc-Agent -- Running the Installation Script on Linux machine
      shell: bash /tmp/Install_linix_azcmagent.sh

    - name: Checking the current version of Installed Arc-Agent
      shell: azcmagent version
      register: linux_arc_agent_version

    - debug:
        var: linux_arc_agent_version

    - name: Connecting Azure-Arc with Azure Resource Group
      command: azcmagent connect \
                  --azure_arc_agent_resource-group "{{azure_arc_agent_resourceGroup}}"
                  --azure_arc_agent_tenant-id "{{azure_arc_agent_tenantId}}"
                  --azure_arc_agent_location "{{azure_arc_agent_locatioon}}"
                  --azure_arc_agent_subscription "{{azure_arc_agent_subscription}}"
                  --azure_arc_agent_tags "{{azure_arc_agent_tags}}"
                  --azure_arc_agent_service-principal-id "{{azure_arc_agent_client_id}}"
                  --azure_arc_agent_service-principal-secret "{{azure_arc_agent_client_secret}}"
      register: final_out
      ignore_errors: yes

    - pause:

    - debug:
        msg: Successfully installed Arc-Agent on host "{{inventory_hostname}}" and registered to "{{azure_arc_agent_resourceGroup}}"

